Name:       libprojectM
Version:    2.1.0
Release:    1%{?dist}
Summary:    The libraries for the projectM music visualization plugin
Group:      Applications/Multimedia
License:    LGPLv2+
URL:        http://projectm.sourceforge.net/
Source0:    http://downloads.sourceforge.net/projectm/%{version}/projectM-complete-%{version}-Source.tar.gz
Patch1:     libprojectM-2.1.0-paths.patch
Patch2:     libprojectM-qt-2.1.0-paths.patch
#Fix FTBFS with GCC6
Patch10:    libprojectM-c++14.patch

BuildRequires:  ftgl-devel cmake glew-devel
BuildRequires:  libgomp pulseaudio-libs-devel
# libprojectM-qt
BuildRequires:  qt4-devel
#projectM-jack
BuildRequires:  jack-audio-connection-kit-devel desktop-file-utils
#projectM-libvisual
BuildRequires:  libvisual-devel = 1:0.4.0, SDL-devel
#projectM-pulseaudio
BuildRequires:  pulseaudio-libs-devel

BuildRequires:  dejavu-sans-mono-fonts, dejavu-sans-fonts
Requires:   dejavu-sans-mono-fonts, dejavu-sans-fonts


%description
projectM is an awesome music visualizer. There is nothing better in the world
of Unix. projectM's greatness comes from the hard work of the community. Users
like you can create presets that connect music with incredible visuals.
projectM is an LGPL'ed reimplementation of Milkdrop under OpenGL. All projectM
requires is a video card with 3D acceleration and your favorite music.

%package    devel
Summary:    Development files for %{name}
Group:      Development/Libraries
Requires:   %{name}%{?_isa} = %{version}-%{release}, pkgconfig

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package qt
Summary:    The Qt frontend to the projectM visualization plugin
Group:      Applications/Multimedia
License:    GPLv2+

%description qt
projectM-qt is a GUI designed to enhance the projectM user and preset writer
experience.  It provides a way to browse, search, rate presets and setup
preset playlists for projectM-jack and projectM-pulseaudio.

%package qt-devel
Summary:    Development files for %{name}-qt
Group:      Development/Libraries
Requires:   %{name}-qt = %{version}-%{release} 
Requires:   pkgconfig libprojectM-devel qt-devel

%description qt-devel
The %{name}-qt-devel package contains libraries and header files for
developing applications that use %{name}-qt.

%package -n projectM-jack
Summary:    The projectM visualization plugin for jack
Group:      Applications/Multimedia
License:    GPLv2+ and MIT

%description -n projectM-jack
This package allows the use of the projectM visualization plugin through any
JACK compatible applications.

%package -n projectM-pulseaudio
Summary:    The projectM visualization plugin for pulseaudio
Group:      Applications/Multimedia
License:    GPLv2+ and MIT

%description -n projectM-pulseaudio
This package allows the use of the projectM visualization plugin through any
pulseaudio compatible applications.

%package -n projectM-libvisual
Summary:    The projectM visualization plugin for libvisual
Group:      Applications/Multimedia
License:    GPLv2+ and LGPLv2+ and MIT

%description -n projectM-libvisual
This package allows the use of the projectM visualization plugin through any
libvisual compatible applications.

%prep
%setup -q -n projectM-complete-%{version}-Source

sed -i 's/\r//' src/libprojectM/ChangeLog
sed -i 's/\r//' src/libprojectM/fftsg.h
sed -i 's/\r//' src/libprojectM/event.h
find -name "*.?pp" -exec chmod -x {} ';'
find -name "*.h" -exec chmod -x {} ';'

%patch1 -p1
%patch2 -p1
%patch10 -p1


%build
export CXXFLAGS="%{optflags} -Wl,--as-needed"
%cmake -DCMAKE_INSTALL_PREFIX=%{_prefix} -DLIB_INSTALL_DIR=%{_libdir} \
 -DprojectM_FONT_TITLE=/usr/share/fonts/dejavu/DejaVuSans.ttf \
 -DprojectM_FONT_MENU=/usr/share/fonts/dejavu/DejaVuSansMono.ttf \
 -DINCLUDE-PROJECTM-TEST=OFF -DINCLUDE-PROJECTM-JACK=ON  .

make %{?_smp_mflags} VERBOSE=1


%install
make install DESTDIR=%{buildroot}
find %{buildroot} -name '*.la' -exec rm -f {} ';'
desktop-file-install --dir=%{buildroot}%{_datadir}/applications src/projectM-jack/projectM-jack.desktop
desktop-file-install --dir=%{buildroot}%{_datadir}/applications src/projectM-pulseaudio/projectM-pulseaudio.desktop

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post qt -p /sbin/ldconfig

%postun qt -p /sbin/ldconfig

%files
%doc src/libprojectM/ChangeLog
%license src/libprojectM/COPYING
%{_libdir}/libprojectM.so.*
%{_datadir}/projectM/

%files devel
%{_includedir}/%{name}
%{_libdir}/libprojectM.so
%{_libdir}/pkgconfig/libprojectM.pc

%files qt
%license src/projectM-qt/COPYING
%{_libdir}/libprojectM-qt*.so.*
%{_datadir}/pixmaps/prjm16-transparent.svg

%files qt-devel
%doc src/projectM-qt/ReadMe
%{_includedir}/%{name}-qt
%{_libdir}/libprojectM-qt*.so
%{_libdir}/pkgconfig/libprojectM-qt*.pc

%files -n projectM-jack
%doc src/projectM-jack/ChangeLog
%license src/projectM-jack/COPYING
%{_bindir}/projectM-jack
%{_datadir}/applications/projectM-jack.desktop

%files -n projectM-pulseaudio
%doc  src/projectM-pulseaudio/ChangeLog 
%license src/projectM-pulseaudio/COPYING
%{_bindir}/projectM-pulseaudio
%{_datadir}/applications/projectM-pulseaudio.desktop

%files -n projectM-libvisual
%doc src/projectM-libvisual/AUTHORS src/projectM-libvisual/ChangeLog 
%license src/projectM-libvisual/COPYING
%{_libdir}/libvisual-0.4/

%changelog
* Wed Mar 16 2016 Sérgio Basto <sergio@serjux.com> - 2.1.0-1
- Update to 2.0.1 .
- deleted: 01-change-texture-size.patch, upstreamed.
- deleted: 04-change-preset-duration.patch, upstreamed.
- deleted: libprojectM-USE_THREADS.patch, configurable.
- deleted: libprojectM-soname.patch, configurable.
- deleted: libprojectM-fonts.patch, configurable.
- deleted: libprojectM-freetype25.patch, it is build well with freetype.
- Add patch to fix FTBFS with GCC6, courtesy of Ralf Corsepius.
- Add as sub packages: libprojectM-qt, libprojectM-qt-devel, projectM-jack,
  projectM-libvisual and projectM-pulseaudio.
- Also checked that remove_pulse_browser_h.patch, projectM-pulseaudio-stat.patch
  and projectM-libvisual-gcc46.patch are upstreamed.
- Add libprojectM-2.1.0-paths.patch and libprojectM-qt-2.1.0-paths.patch, to fix
  _libdir paths 
- Using fedora-review fixed: mix tabs and spaces,
  unused-direct-shlib-dependency, wrong-script-end-of-line-encoding and
  spurious-executable-perm.

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.1-28
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jan 14 2016 Adam Jackson <ajax@redhat.com> - 2.0.1-27
- Rebuild for glew 1.13

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-26
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 2.0.1-25
- Rebuilt for GCC 5 C++11 ABI change

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-24
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Mon Jun 30 2014 Yaakov Selkowitz <yselkowi@redhat.com> - 2.0.1-23
- Fix FTBFS with freetype-2.5 (#1106066)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-22
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Nov 18 2013 Dave Airlie <airlied@redhat.com> - 2.0.1-21
- rebuilt for GLEW 1.10

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-20
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Dec 13 2012 Adam Jackson <ajax@redhat.com> - 2.0.1-18
- Rebuild for glew 1.9.0

* Thu Jul 26 2012 Rex Dieter <rdieter@fedoraproject.org> 2.0.1-17
- rebuild (glew)

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jun  1 2012 Michael Schwendt <mschwendt@fedoraproject.org> - 2.0.1-15
- Enhancement of the patch in 2.0.1-11: also override invalid font paths
  passed in by applications as these lead to an immediate crash. (#664088)
- Make -devel base pkg dep arch-specific.

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-14
- Rebuilt for c++ ABI breakage

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Jun 20 2011 ajax@redhat.com - 2.0.1-12
- Rebuild for new glew soname

* Sat May  7 2011 Michael Schwendt <mschwendt@fedoraproject.org> - 2.0.1-11
- Also BuildRequires the desired font packages for the safety-checks.
- Drop obsolete README.fedora file since users need not modify their
  config file manually anymore to prevent projectM from crashing.
- Revise fonts patch: check that user's configured font files exist,
  fall back to our defaults, add safety-check in spec file, replace
  font paths in prep section. (#698404, #698381)

* Mon Apr 25 2011 Jameson Pugh <imntreal@gmail.com> - 2.0.1-10
- Fixed fonts patch

* Wed Mar 23 2011 Jameson Pugh <imntreal@gmail.com> - 2.0.1-9
- Correct typo in requirements

* Tue Mar 15 2011 Jameson Pugh <imntreal@gmail.com> - 2.0.1-8
- Replace obsolete bitstream-vera font requirements with dejavu

* Sat Jul 17 2010 Jameson Pugh (imntreal@gmail.com) - 2.0.1-7
- Updated font patch with Orcan's changes

* Sat Jul 10 2010 Jameson Pugh (imntreal@gmail.com) - 2.0.1-6
- Added patches so clementine can be built against it

* Fri May 21 2010 Jameson Pugh (imntreal@gmail.com) - 2.0.1-5
- Don't create fonts directory
- Add a README.fedora for instructions on upgrading from -3

* Mon Apr 05 2010 Jameson Pugh (imntreal@gmail.com) - 2.0.1-4
- Got rid of font symlinks

* Mon Feb 08 2010 Jameson Pugh (imntreal@gmail.com) - 2.0.1-3
- Patch to remove the USE_THREADS option pending an update from upstream

* Sun Jan 10 2010 Jameson Pugh (imntreal@gmail.com) - 2.0.1-2
- Made needed soname bump

* Sun Dec 13 2009 Jameson Pugh (imntreal@gmail.com) - 2.0.1-1
- New release

* Mon Oct 12 2009 Jameson Pugh (imntreal@gmail.com) - 1.2.0r1300-1
- SVN Release to prepare for v2

* Wed Feb 25 2009 Jameson Pugh (imntreal@gmail.com) - 1.2.0-9
- Aparently stdio.h didn't need to be included in BuiltinParams.cpp before, but is now

* Tue Feb 24 2009 Jameson Pugh (imntreal@gmail.com) - 1.2.0-8
- Font packages renamed

* Fri Jan 02 2009 Jameson Pugh (imntreal@gmail.com) - 1.2.0-7
- Per recommendation, switched font packages from bitstream to dejavu

* Mon Dec 22 2008 Jameson Pugh (imntreal@gmail.com) - 1.2.0-6
- Updated font package names

* Tue Nov 04 2008 Jameson Pugh (imntreal@gmail.com) - 1.2.0-5
- Moved sed command from prep to install
- Correct libprojectM.pc patch

* Thu Oct 30 2008 Jameson Pugh (imntreal@gmail.com) - 1.2.0-4
- Removed patch for ChangeLog, and used sed command in the spec
- Added VERBOSE=1 to the make line
- Added patch to correct libprojectM.pc

* Wed Oct 29 2008 Jameson Pugh (imntreal@gmail.com) - 1.2.0-3
- Added a patch to correct ChangeLog EOL encoding
- Cleaned up all Requires and BuildRequires
- Corrected ownership of include/libprojectM and data/projectM
- Removed unnecessary cmake arguments

* Wed Sep 24 2008 Jameson Pugh (imntreal@gmail.com) - 1.2.0-2
- Removed fonts from package
- Added symlinks to the fonts due to hard coded programing

* Tue Sep 02 2008 Jameson Pugh (imntreal@gmail.com) - 1.2.0-1
- New release
- 64-bit patch no longer needed

* Mon Mar 31 2008 Jameson Pugh (imntreal@gmail.com) - 1.1-1
- New release

* Wed Dec 05 2007 Jameson Pugh <imntreal@gmail.com> - 1.01-1
- Initial public release of the package
